Package ch.qos.logback.core.util

## Class OptionHelper

- java.lang.Object
- - ch.qos.logback.core.util.OptionHelper

    public class OptionHelper
    extends java.lang.Object

Author:
  Ceki Gulcu

### Constructor Summary

Constructors
`OptionHelper()`

### Method Summary

All Methods Static Methods Concrete Methods
`static java.lang.String[]` `extractDefaultReplacement​(java.lang.String key)` Return a String[] of size two.
`static java.lang.String` `getEnv​(java.lang.String key)` Lookup a key from the environment.
`static java.util.Properties` `getSystemProperties()` Very similar to `System.getProperties()` except that the `SecurityException` is absorbed.
`static java.lang.String` `getSystemProperty​(java.lang.String key)` Very similar to `System.getProperty` except that the `SecurityException` is absorbed.
`static java.lang.String` `getSystemProperty​(java.lang.String key, java.lang.String def)` Very similar to `System.getProperty` except that the `SecurityException` is absorbed.
`static java.lang.Object` `instantiateByClassName​(java.lang.String className, java.lang.Class<?> superClass, Context context)`
`static java.lang.Object` `instantiateByClassName​(java.lang.String className, java.lang.Class<?> superClass, java.lang.ClassLoader classLoader)`
`static java.lang.Object` `instantiateByClassNameAndParameter​(java.lang.String className, java.lang.Class<?> superClass, Context context, java.lang.Class<?> type, java.lang.Object param)`
`static java.lang.Object` `instantiateByClassNameAndParameter​(java.lang.String className, java.lang.Class<?> superClass, java.lang.ClassLoader classLoader, java.lang.Class<?> type, java.lang.Object parameter)`
`static boolean` `isEmpty​(java.lang.String str)`
`static java.lang.String` `propertyLookup​(java.lang.String key, PropertyContainer pc1, PropertyContainer pc2)`
`static void` `setSystemProperties​(ContextAware contextAware, java.util.Properties props)`
`static void` `setSystemProperty​(ContextAware contextAware, java.lang.String key, java.lang.String value)`
`static java.lang.String` `substVars​(java.lang.String val, PropertyContainer pc1)`
`static java.lang.String` `substVars​(java.lang.String input, PropertyContainer pc0, PropertyContainer pc1)` See http://logback.qos.ch/manual/configuration.html#variableSubstitution
`static boolean` `toBoolean​(java.lang.String value, boolean dEfault)` If `value` is "true", then `true` is returned.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### OptionHelper

    public OptionHelper()

### Method Detail

#### instantiateByClassName

    public static java.lang.Object instantiateByClassName​(java.lang.String className,
                                                          java.lang.Class<?> superClass,
                                                          Context context)
                                                   throws IncompatibleClassException,
                                                          DynamicClassLoadingException

Throws:
  `IncompatibleClassException`
  `DynamicClassLoadingException`

#### instantiateByClassNameAndParameter

    public static java.lang.Object instantiateByClassNameAndParameter​(java.lang.String className,
                                                                      java.lang.Class<?> superClass,
                                                                      Context context,
                                                                      java.lang.Class<?> type,
                                                                      java.lang.Object param)
                                                               throws IncompatibleClassException,
                                                                      DynamicClassLoadingException

Throws:
  `IncompatibleClassException`
  `DynamicClassLoadingException`

#### instantiateByClassName

    public static java.lang.Object instantiateByClassName​(java.lang.String className,
                                                          java.lang.Class<?> superClass,
                                                          java.lang.ClassLoader classLoader)
                                                   throws IncompatibleClassException,
                                                          DynamicClassLoadingException

Throws:
  `IncompatibleClassException`
  `DynamicClassLoadingException`

#### instantiateByClassNameAndParameter

    public static java.lang.Object instantiateByClassNameAndParameter​(java.lang.String className,
                                                                      java.lang.Class<?> superClass,
                                                                      java.lang.ClassLoader classLoader,
                                                                      java.lang.Class<?> type,
                                                                      java.lang.Object parameter)
                                                               throws IncompatibleClassException,
                                                                      DynamicClassLoadingException

Throws:
  `IncompatibleClassException`
  `DynamicClassLoadingException`

#### substVars

    public static java.lang.String substVars​(java.lang.String val,
                                             PropertyContainer pc1)

See Also:
  `substVars(String, PropertyContainer, PropertyContainer)`

#### substVars

    public static java.lang.String substVars​(java.lang.String input,
                                             PropertyContainer pc0,
                                             PropertyContainer pc1)

See http://logback.qos.ch/manual/configuration.html#variableSubstitution

#### propertyLookup

    public static java.lang.String propertyLookup​(java.lang.String key,
                                                  PropertyContainer pc1,
                                                  PropertyContainer pc2)

#### getSystemProperty

    public static java.lang.String getSystemProperty​(java.lang.String key,
                                                     java.lang.String def)

Very similar to `System.getProperty` except that the `SecurityException` is absorbed.

Parameters:
  `key` - The key to search for.
  `def` - The default value to return.
Returns:
  the string value of the system property, or the default value if there is no property with that key.

#### getEnv

    public static java.lang.String getEnv​(java.lang.String key)

Lookup a key from the environment.

Parameters:
  `key` -
Returns:
  value corresponding to key from the OS environment

#### getSystemProperty

    public static java.lang.String getSystemProperty​(java.lang.String key)

Very similar to `System.getProperty` except that the `SecurityException` is absorbed.

Parameters:
  `key` - The key to search for.
Returns:
  the string value of the system property.

#### setSystemProperties

    public static void setSystemProperties​(ContextAware contextAware,
                                           java.util.Properties props)

#### setSystemProperty

    public static void setSystemProperty​(ContextAware contextAware,
                                         java.lang.String key,
                                         java.lang.String value)

#### getSystemProperties

    public static java.util.Properties getSystemProperties()

Very similar to `System.getProperties()` except that the `SecurityException` is absorbed.

Returns:
  the system properties

#### extractDefaultReplacement

    public static java.lang.String[] extractDefaultReplacement​(java.lang.String key)

Return a String[] of size two. The first item containing the key part and the second item containing a default value specified by the user. The second item will be null if no default value is specified.

Parameters:
  `key` -
Returns:

#### toBoolean

    public static boolean toBoolean​(java.lang.String value,
                                    boolean dEfault)

If `value` is "true", then `true` is returned. If `value` is "false", then `true` is returned. Otherwise, `default` is returned.

Case of value is unimportant.

#### isEmpty

    public static boolean isEmpty​(java.lang.String str)